// DOptions.cpp : implementation file
//

#include "stdafx.h"
#include "AICONMoveInspectApp.h"
#include "DOptions.h"


// DOptions dialog

IMPLEMENT_DYNAMIC(DOptions, CDialog)

DOptions::DOptions(CWnd* pParent /*=NULL*/)	:
#ifdef _PIPELINE
CDialog(DOptions::IDD, pParent),
#endif
// CDialog(DOptions::IDD, pParent)
m_codedtarget_id(1),
m_list(*this)
, m_storePointsMethod(0)
{

}

DOptions::~DOptions()
{
}

void DOptions::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_LIST1, m_list);
    DDX_Text(pDX, IDC_TARGET_EDIT, m_codedtarget_id);
    DDV_MinMaxInt(pDX, m_codedtarget_id, 1, 5000);
    DDX_Check(pDX, IDC_CODED_CHECK, m_bCoded);
    DDX_Check(pDX, IDC_NONCODED_CHECK, m_bNonCoded);
    DDX_Check(pDX, IDC_ADAPTER_FRAMES_CHECK, m_bAdapterFrames);
    DDX_Check(pDX, IDC_ADAPTER_POINTS_CHECK, m_bAdapterPoints);
    DDX_Check(pDX, IDC_AUTO_GRP_INCR_CHECK, m_bAutoGroupIncrement);
    DDX_Control(pDX, IDC_SNAPSHOT_BUTTON, m_snapBtnCtrl);
    DDX_Radio(pDX, IDC_STORE_POINTS_TRIGGERED_RADIO, m_storePointsMethod);
}


BEGIN_MESSAGE_MAP(DOptions, CDialog)
	ON_WM_DESTROY()
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_ADD_BUTTON, &DOptions::OnBnClickedAdd)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, &DOptions::OnBnClickedDelete)
	ON_BN_CLICKED(IDOK, &DOptions::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &DOptions::OnBnClickedCancel)
    ON_BN_CLICKED(IDC_CODED_CHECK, &DOptions::OnPointTypeCheckClicked)
    ON_BN_CLICKED(IDC_NONCODED_CHECK, &DOptions::OnPointTypeCheckClicked)
    ON_BN_CLICKED(IDC_ADAPTERS_CHECK, &DOptions::OnPointTypeCheckClicked)
    ON_BN_CLICKED(IDC_SNAPSHOT_BUTTON, &DOptions::OnBnClickedFrameSnapshotButton)
    ON_BN_CLICKED(IDC_STORE_POINTS_TRIGGERED_RADIO, &DOptions::OnBnClickedStorePointsTriggeredRadio)
    ON_BN_CLICKED(IDC_STORE_POINTS_ALWAYS_RADIO, &DOptions::OnBnClickedStorePointsAlwaysRadio)
END_MESSAGE_MAP()


// DOptions message handlers

BOOL DOptions::OnInitDialog()
{
	CDialog::OnInitDialog();
#ifndef _PIPELINE
	TRANSLATE_DIALOG;
#endif

	m_list.SetExtendedStyle(m_list.GetExtendedStyle() | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES /*| LVS_EX_CHECKBOXES*/ | LVS_EX_FLATSB  );
	m_list.EnableToolTips();

	int col = 0;
	m_list.InsertColumn(col, _T("Target ID"), LVCFMT_LEFT, -1, col);
	m_list.SetColumnWidth(col++, LVSCW_AUTOSIZE_USEHEADER );

    m_storePointsMethod = m_bStorePointsTriggered ? 0 : 1;

	PopulateList();

    UpdateSnapshot(m_bSnapShot);

    if (m_bStorePointsAlways)
    {
        m_storePointsMethod = 1;
        UpdateData(FALSE);
    }
#ifndef _PIPELINE
	DialogHelper::MakeAllGroupBoxesBold(this);
#endif
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void DOptions::OnDestroy()
{
#ifndef _PIPELINE
	PersistentWnd::SaveWndRect(_T("windows"),_T("DOptions"),this);
#endif
	CDialog::OnDestroy();
}

void DOptions::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);
#ifndef _PIPELINE
	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("DOptions"),this);
#endif
}

void DOptions::OnBnClickedAdd()
{
	if (UpdateData(TRUE))
	{
		m_codedTargetIDs.Add(m_codedtarget_id);
		PopulateList();

		int cnt = m_list.GetItemCount();
		m_list.EnsureRowVisible(cnt-1);
		m_list.SetSingleSelection(cnt-1);	

		m_codedtarget_id++;
		UpdateData(FALSE);
	}
}

void DOptions::OnBnClickedDelete()
{
	DWORD_PTR sel;
	if (m_list.GetSingleSelection(sel))
	{
		m_codedTargetIDs.RemoveAt(sel);
		PopulateList();
	}
}

void DOptions::OnBnClickedOk()
{
	OnOK();
}

void DOptions::OnBnClickedCancel()
{
	OnCancel();
}

void DOptions::PopulateList()
{
	DWORD_PTR originalSelection = 0;
	if (!m_list.GetSingleSelection(originalSelection))
	{
		originalSelection = 0;
	}
	else if (originalSelection >= m_codedTargetIDs.GetSize())
	{
		originalSelection = m_codedTargetIDs.GetSize()-1;
	}

	m_list.SetRedraw(FALSE);
	m_list.DeleteAllItems();

	int row = 0; 
	int col = 0;
	for ( INT_PTR i = 0; i < m_codedTargetIDs.GetSize(); i++)
	{
		WORD val = m_codedTargetIDs[i];
		CString sVal;
		sVal.Format(_T("%d"), val);
		m_list.InsertItem(row,sVal);
		m_list.SetItemData(row,i);

		m_list.SetItemText(row,col++,sVal);
		row++;
	}

	m_list.SetSingleSelection(originalSelection);	
	m_list.SetRedraw(TRUE);
}

void DOptions::OnPointTypeCheckClicked()
{
    m_bCoded = ((CButton*)GetDlgItem(IDC_CODED_CHECK))->GetCheck();
    m_bNonCoded = ((CButton*)GetDlgItem(IDC_NONCODED_CHECK))->GetCheck();
    m_bAdapterFrames = ((CButton*)GetDlgItem(IDC_ADAPTER_FRAMES_CHECK))->GetCheck();
    m_bAdapterPoints = ((CButton*)GetDlgItem(IDC_ADAPTER_POINTS_CHECK))->GetCheck();

    GetDlgItem(IDC_SNAPSHOT_BUTTON)->EnableWindow(m_bAdapterFrames);
}

void DOptions::UpdateSnapshot(const BOOL& bState)
{
    if (bState)
    {
        m_snapBtnCtrl.SetFaceColor(RGB(100,200,75), TRUE);
    }
    else
    {
        m_snapBtnCtrl.SetFaceColor(GetSysColor(COLOR_BTNFACE), TRUE);
    }
}

BOOL DOptions::ToggleSnapShot()
{
    BOOL bSuccess = TRUE;

    m_bSnapShot = !m_bSnapShot;
    UpdateSnapshot(m_bSnapShot);

    return bSuccess;
}

void DOptions::OnBnClickedFrameSnapshotButton()
{
    ToggleSnapShot();
}


void DOptions::OnBnClickedStorePointsTriggeredRadio()
{
    m_bStorePointsAlways = FALSE;
    m_bStorePointsTriggered = TRUE;
}


void DOptions::OnBnClickedStorePointsAlwaysRadio()
{
    m_bStorePointsAlways = TRUE;
    m_bStorePointsTriggered = FALSE;
}
