#pragma once
#include "afxwin.h"
#include <afxbutton.h>


// DOptions dialog

class DOptions : public CDialog
{
	DECLARE_DYNAMIC(DOptions)

public:
	DOptions(CWnd* pParent = NULL);   // standard constructor
	virtual ~DOptions();

// Dialog Data
	enum { IDD = IDD_OPTIONS_DIALOG };

	CWordArray m_codedTargetIDs;

    BOOL m_bCoded;
    BOOL m_bNonCoded;
    BOOL m_bAdapterFrames;
    BOOL m_bAdapterPoints;

    BOOL m_bStorePointsAlways;
    BOOL m_bStorePointsTriggered;
    BOOL m_bSnapShot;

    BOOL m_bAutoGroupIncrement;

protected:
	class CodedTargetIdentifierFancyList : public FancyList
	{
	public:
		CodedTargetIdentifierFancyList(DOptions& dlg)
			: dialog(dlg)
		{
		}

	private:
		DOptions& dialog;
	};
	friend CodedTargetIdentifierFancyList;  // grant friendship so we can access cont.

	CodedTargetIdentifierFancyList m_list;
	int m_codedtarget_id;

	void PopulateList();

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();

	afx_msg void OnDestroy();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);

	afx_msg void OnBnClickedAdd();
	afx_msg void OnBnClickedDelete();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();

    afx_msg void OnPointTypeCheckClicked();

    afx_msg void OnBnClickedFrameSnapshotButton();
    afx_msg void OnBnClickedStorePointsTriggeredRadio();
    afx_msg void OnBnClickedStorePointsAlwaysRadio();

	DECLARE_MESSAGE_MAP()

private:
    CMFCButton m_snapBtnCtrl;
    int m_storePointsMethod;

    BOOL ToggleSnapShot();
    void UpdateSnapshot(const BOOL& bState);
};
