#pragma once

#include "MouseAction.h"

//
// CForceFitStatic
//
// NOTE: To use this class, make sure that the NOTIFY property of the dialog control
//       that this will be used with is set to TRUE.
//
// Also, when using a dialog that also uses a CString variable with the CStatic, you'll
//   need to remember the following:
//
// 1) MUST have DDX_Text before the DDX_Control
//  
//  DDX_Text(pDX, IDC_MYSTATIC, m_staticStr);
//  
//  DDX_Control(pDX, IDC_MYSTATIC, m_staticCtrl);
//  
// 2) If you're going to set the CString associated with a control in OnInitDialog, 
//    the initialization of that string MUST preceed the call to CDialog::OnInitDialog
//  
// BOOL DTargetInfo::OnInitDialog() 
// {
//  m_staticStr = _T("Hello");
//  CDialog::OnInitDialog();
//
class CForceFitStatic : public CMouseAction
{
public:
	CForceFitStatic();
	virtual ~CForceFitStatic();

	void SetWindowText(const CString& strText);
	void SetIndicatorText(const CString& indicatorText);
	BOOL RedrawWindow();

	// jmc - pulled over functions from NewColorStatic so we can use the force-fit capability and still control colors.
	void SetTextColor(COLORREF crColor); // This Function is to set the Color for the Text.
	void SetBkColor(COLORREF crColor); // This Function is to set the BackGround Color for the Text.
	void SetDefaultBkColor();
	void SetDefaultTextColor();
	COLORREF GetTextColor();
	COLORREF GetBkColor();

protected:
	CString			m_indicatorText;
	BOOL			m_bTransparentBk;
	COLORREF		m_rgbBkgnd;
	COLORREF		m_rgbText;
	CString			m_strText;
	BOOL			m_bTracking;
	BOOL			m_bHover;

	DECLARE_MESSAGE_MAP()

	// TEXT METHODS
	void	DrawText(CDC* pDC, CRect* pRect, const CString& csText);

	// MESSAGE HANDLER
	afx_msg void OnPaint();

	virtual void PreSubclassWindow();

};


